
var oField  	= null;
var sPassword	= "";

var iSkip	 	= 0;
var iRotate		= 0;
var iCount		= 0;
var iCountSeed	= 20;
var iDelay		= 20;
var iNumChars	= 6;
var isMixedCase	= true;
var isUpperCase	= false;
var isMnemonic	= false;


var sAlpha		= "abcdefghijklmnopqrstuvwxyz";
var sVowel		= "aeiou";
var sConsonant	= "bcdfghjklmnpqrstvwxyz";
var sNumbers	= "1234567890";
var	sOther		= "$@_!";
var	sExclude	= "";
var	aChars		= new Array();
var sLastLastChar	= "";
var sLastChar		= "";

// Hands
var handSelected	= false;
var sValidHandChars	= "";
var aHands			= new Array();
	aHands['left'] 	= "abcdefgqrstvwxz" + "123456" + "`~!@#$%^";
	aHands['right']	= "hijklmnopuy" + "7890" + "&*()-_=+{}|[]\:\";'<>?,./";

function securepassword_init(){

	// Check for updates
	setTimeout("securepassword_autoUpdate()", 500);
	
	// Load Prefs
	try{
		var oPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
		
		// Password Length
		if(oPrefs.prefHasUserValue("securepassword.characters.length"))
			document.getElementById("num-chars-field").value = oPrefs.getIntPref("securepassword.characters.length");
			
		// Numbers	
		if(oPrefs.prefHasUserValue("securepassword.characters.numbers"))
			document.getElementById("numbers-check").checked = oPrefs.getBoolPref("securepassword.characters.numbers");
		if(oPrefs.prefHasUserValue("securepassword.characters.numbers.scale"))
			document.getElementById("num-weight").setAttribute("curpos", oPrefs.getIntPref("securepassword.characters.numbers.scale"));
			
		// Letters
		if(oPrefs.prefHasUserValue("securepassword.characters.alpha"))
			document.getElementById("letters-check").checked = oPrefs.getBoolPref("securepassword.characters.alpha");
		if(oPrefs.prefHasUserValue("securepassword.characters.alpha.scale"))
			document.getElementById("alpha-weight").setAttribute("curpos", oPrefs.getIntPref("securepassword.characters.alpha.scale"));
		if(oPrefs.prefHasUserValue("securepassword.characters.alpha.case"))
			document.getElementById("alpha-case-list").value = oPrefs.getIntPref("securepassword.characters.alpha.case");
			
		// Other
		if(oPrefs.prefHasUserValue("securepassword.characters.other"))
			document.getElementById("others-check").checked = oPrefs.getBoolPref("securepassword.characters.other");
		if(oPrefs.prefHasUserValue("securepassword.characters.other.scale"))
			document.getElementById("other-weight").setAttribute("curpos", oPrefs.getIntPref("securepassword.characters.other.scale"));
		if(oPrefs.prefHasUserValue("securepassword.characters.other.chars"))
			document.getElementById("others-chars-field").value = oPrefs.getCharPref("securepassword.characters.other.chars");
			
		// Excludes
		if(oPrefs.prefHasUserValue("securepassword.characters.exclude"))
			document.getElementById("exclude-check").checked = oPrefs.getBoolPref("securepassword.characters.exclude");
		if(oPrefs.prefHasUserValue("securepassword.characters.exclude.chars"))
			document.getElementById("exclude-chars-field").value = oPrefs.getCharPref("securepassword.characters.exclude.chars");
			
		// Mnemonic
		if(oPrefs.prefHasUserValue("securepassword.mnemonic")){
			document.getElementById("mnemonic-check").checked = oPrefs.getBoolPref("securepassword.mnemonic");	
		}
		
		// Hands
		if(oPrefs.prefHasUserValue("securepassword.hands")){
			document.getElementById("hands-list").value = oPrefs.getIntPref("securepassword.hands");	
		}
		
	} catch(err) { alert(err) }
}

function securePassword_initVals(){
	
	oField.value	= "";
	sPassword		= "";
	aChars			= new Array();
	iNumChars 		= parseInt(document.getElementById("num-chars-field").value);
	
	//Get Character Types & Weights
		
		// Mnemonic
		isMnemonic = document.getElementById("mnemonic-check").checked;
		
		// Hands
		switch(parseInt(document.getElementById("hands-list").value)) {
			case 0:
				handSelected	= false;
				break;
			case 1:
				handSelected 	= true;
				sValidHandChars = aHands['left'];
				break;
			case 2:
				handSelected 	= true;
				sValidHandChars = aHands['right'];
				break;
		}
		
		if(isMnemonic == true || handSelected){
			iDelay 		= iDelay / 2;
			iCountSeed	= iCountSeed / 2;
		}
		
		//Numbers
		if(!isMnemonic && document.getElementById("numbers-check").checked && !isMnemonic){
			
			var iWeight = getWeight("num");
			for(var w = 0; w < iWeight; w++)
				aChars[aChars.length] = sNumbers;
		}
		//Letters
		if(isMnemonic || document.getElementById("letters-check").checked){
			
			var iWeight = getWeight("alpha");
			for(var w = 0; w < iWeight; w++)
				aChars[aChars.length] = sAlpha;
			
			//Case
			switch(parseInt(document.getElementById("alpha-case-list").value)) {
				case 0:
					isMixedCase = false;
					isUpperCase	= false;
					break;
				case 1:
					isMixedCase = false;
					isUpperCase	= true;
					break;
				case 2:
					isMixedCase = true;
					isUpperCase	= false;
					break;
			}
		}
		//Other
		if(!isMnemonic && document.getElementById("others-check").checked && !isMnemonic){
			sOther = document.getElementById("others-chars-field").value;
			
			if(sOther != ""){
				var iWeight = getWeight("other");
				for(var w = 0; w < iWeight; w++)
					aChars[aChars.length] = sOther;
			}
		}
		// Exclude
		if(document.getElementById("exclude-check").checked){
			sExclude = document.getElementById("exclude-chars-field").value.toLowerCase();
		}
	
}

function securePassword_create(){
	oField = document.getElementById("password-field");
	
	try{
		securePassword_initVals();
		securePassword_nextChar();
	} catch(err) { alert("An error occurred\n"+ err)}
}

function securePassword_nextChar(){
	
	try{
		iCount = Math.round(Math.random() * iCountSeed);
		
		//If not at character limit
		if(sPassword.length < iNumChars){
			securePassword_generate();
		}
		//End
		else{
			document.getElementById("copy-label").style.display = "block";
		}
	} catch(err) { throw err; }
}

function securePassword_generate(){
	
	try{
			
		//Char Type
		var iWhich	= Math.round(Math.random() * (aChars.length - 1));	
		var sChars	= aChars[iWhich];
		
		//Char
		var iChar = Math.round(Math.random() * (sChars.length - 1));
		var sChar = sChars.substring(iChar, iChar + 1);
		
		//Text Case
		if(isMixedCase && sChar.match(/[a-z]/g)){
			var iCap = Math.random();
			if(iCap > 0.5){
				sChar = sChar.toUpperCase();
			}
		}
		else if(isUpperCase){
			sChar = sChar.toUpperCase();
		}
		
		//Update
		oField.value = sPassword + sChar;
		
		// Character Already Used
		if(sPassword.indexOf(sChar) > -1 && !isMnemonic 
				&& sChars.length > 0 && sPassword.length < (sChars.length / 2)
				&& iSkip < 10){
			iSkip++;
			setTimeout("securePassword_generate()", iDelay);
		}
		// Excluded Char
		else if(sExclude.indexOf(sChar.toLowerCase()) > -1){
			iSkip++;
			setTimeout("securePassword_generate()", iDelay);
		}
		// Mnemonic Consonant (make sure that there is one vowel every 2 consonants)
		else if(isMnemonic 
				&& sVowel.indexOf(sChar.toLowerCase()) < 0
				&& sVowel.indexOf(sLastChar.toLowerCase()) < 0 
				&& sVowel.indexOf(sLastLastChar.toLowerCase()) < 0
				&& iSkip < 10){
				iSkip++;
				setTimeout("securePassword_generate()", iDelay);	
		}
		// Mnemonic Vowel (make sure that there is no more than 2 vowels together)
		else if(isMnemonic 
				&& sVowel.indexOf(sChar.toLowerCase()) > -1
				&& sVowel.indexOf(sLastChar.toLowerCase()) > -1 
				&& sVowel.indexOf(sLastLastChar.toLowerCase()) > -1
				&& iSkip < 10){
				iSkip++;
				setTimeout("securePassword_generate()", iDelay);	
		}
		// Hands
		else if(handSelected == true 
				&& sValidHandChars.indexOf(sChar.toLowerCase()) < 0
				&& iSkip < 10){
			iSkip++;
			setTimeout("securePassword_generate()", iDelay);
		}
		// End
		else if(iCount == 0){
			sPassword 		= sPassword + sChar;
			sLastLastChar 	= sLastChar;
			sLastChar 		= sChar;
			iSkip 			= 0;
			setTimeout("securePassword_nextChar()", iDelay);
		}
		//Continue
		else{
			iCount--;
			setTimeout("securePassword_generate()", iDelay);
		}
		
	} catch(err) { throw err; }
}

function getWeight(sChar){
	var oScale 	= document.getElementById(sChar +"-weight");
	var iWeight	= 1;	
	
	if(oScale != null && oScale.getAttribute("curpos") > 0){
		iWeight = Math.round((oScale.getAttribute("curpos") / 500) + 1);
	}
	
	return iWeight;
}

function validateNumChars(){
	var oNum = document.getElementById("num-chars-field");
	
	if(isNaN(oNum.value)){
		alert("The character field must be a number");
		oNum.value = iNumChars;
		oNum.focus();
	}
	else if(parseInt(oNum.value) < 2){
		alert("The password must contain at least 2 charaters");
		oNum.value = 2;
		oNum.focus();
	}
}

//Copy Password to Clipboard
function securePassword_copy(){
	try{
		var sPassword	= oField.value;
		var oClipboard 	= Components.classes["@mozilla.org/widget/clipboardhelper;1"].getService(Components.interfaces.nsIClipboardHelper);
	  		oClipboard.copyString(sPassword);
	}catch(err){
		alert("Couldn't copy to clipboard\n"+ err);
	}
}

// Save option selection
function securepassword_savePrefs(){
	
	try{
		var oPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
			
		// Password Length
		try{
			oPrefs.setIntPref("securepassword.characters.length", parseInt(document.getElementById("num-chars-field").value));
		}catch(err){}
			
		// Numbers		
		oPrefs.setBoolPref("securepassword.characters.numbers", document.getElementById("numbers-check").checked);
		oPrefs.setIntPref("securepassword.characters.numbers.scale", document.getElementById("num-weight").getAttribute("curpos"));
			
		// Letters
		oPrefs.setBoolPref("securepassword.characters.alpha", document.getElementById("letters-check").checked);
		oPrefs.setIntPref("securepassword.characters.alpha.scale", document.getElementById("alpha-weight").getAttribute("curpos"));
		oPrefs.setIntPref("securepassword.characters.alpha.case", parseInt(document.getElementById("alpha-case-list").getAttribute("value")));
		
		// Other
		oPrefs.setBoolPref("securepassword.characters.other", document.getElementById("others-check").checked);
		oPrefs.setIntPref("securepassword.characters.other.scale", document.getElementById("other-weight").getAttribute("curpos"));
		oPrefs.setCharPref("securepassword.characters.other.chars", document.getElementById("others-chars-field").value);
		
		// Exclude
		oPrefs.setBoolPref("securepassword.characters.exclude", document.getElementById("exclude-check").checked);
		oPrefs.setCharPref("securepassword.characters.exclude.chars", document.getElementById("exclude-chars-field").value);
		
		// Mnemonic
		oPrefs.setBoolPref("securepassword.mnemonic", document.getElementById("mnemonic-check").checked);
		
		// Hands
		oPrefs.setIntPref("securepassword.hands", document.getElementById("hands-list").value);
	
	} catch(err) { alert("Error saving options!\n"+ err); }
}
